#!/usr/bin/perl
#
#
#      Common routines for mtn
#                                                           logic@nocrew.org
#
#      This file is not to be executed directly.
#
#
#
#      23rd Mars     - Fixed alot of bugs in poll_mail(), now actually works.
#                    - Verified that send_packet() and poll_mail() works. They Do.
#
#
#
#      Copyright (C) Magnus Lundstrm 1999

return(1);
sub send_packet {
  my $packet = "@_" ;
  dbg("Attempting to send packet. (", length($packet), ") bytes (pre-encoded)", 6);
  dbg("Packet=[$packet];", 10) ;
  dbg("CommadLine: $encoder $encoder_parms | $mta $recipient -s $rsubject_trigger", 7);

  open SEND, "| $encoder $encoder_parms | $mta -s $rsubject_trigger $recipient" or die "$0: open: $!\n" ; 

  print SEND "$packet" ;
  print SEND "\n.\n" if ($mta_EOF_fix) ;

  close SEND or die "$0: close: $!\n" ;
  return(1);
}



sub poll_mail {
  dbg("poll_mail begin", 4) ;
  my $where = 0 ;   # situational awareness variable
  my $lastline = "" ;
  my $origline = "" ;

# DEBUG(10): poll_mail:DROPloop line=[From root Thu Mar 18 17:50:49 1999]

  while (<DROPFD>) {

#	$bits="";
#	vec($bits,fileno(DROPFD),1) = 1;
#	$n=select($foo=$bits, undef, undef, 1);  #  Thanks Lars(@nocrew.org)
#	dbg("poll_mail: select() == $n", 6) ;
#	if ($n == 0) { return(0) ; } # if no new data is in the maildrop, bail out
#	if ($n < 0) { return(1) ; }  # error.. bail out   (error-handlers coming up...)

#    $_ = <DROPFD> ;

    dbg("poll_mail:DROPloop where=$where", 6);

    chomp($origline = $_) ;

    dbg("poll_mail:DROPloop line=[$origline]", 10);
    dbg("poll_mail:DROPloop last=[$lastline]", 10);
    dbg("poll_mail:where=", (($where == 0) or 0), "($where), FromOk=", ((/^From\s(\S+)/) or 0), ", newline-preceed=", (($lastline eq "") or 0), ";", 7) ;
    
   if ((/^From\s(\S+)/) && ($lastline eq "")) {    # First line of Message ("From foo@bar.net ..")
   dbg("poll_mail: FromExpression = true", 6) ;
   $msg{From} = $1 ;
   $msg{body} = undef ;
      $where = 1;
    } elsif ($where > 0) {
    dbg("poll_mail: FromExpression = false", 7) ;
      if ($where == 1 && (/^Subject:\s+(\S+)/)) { # Find Subject to verify if this msg is for us
	if ($1 ne $subject_trigger) {   
	  $where = 0 ;           # message is not for us, look for next message
	  $msg = undef  ;
	} else {            
	  $where = 2 ;           # great, this is for us.
	}
      } elsif ($where > 1) {
	if ($where == 2 && (/^begin\s\d+\s\S+/)) { # beginning of uuencoded message
	  dbg("poll_mail: found begin line", 5);
	  $msg{body}.=$_ ;       # append it to the body
	  $where = 3 ;
	} elsif ($where == 3) {
	  $msg{body}.=$_ ;
	  if (/^end/) {
	    dbg("poll_mail: found end line", 5);
	    $where = 0 ;
	    $origmsg = "";
	    dbg("poll_mail: \$msg data = \{\n", $msg{body}, "\n\}", 10) ;
	    
	    dbg("poll_mail: pre-decode (", time(), ")", 7);

	    dbg("poll_mail: printing messagebody to $tmpfile_prefix$$", 5) ;
	    open (DECFD, ">$tmpfile_prefix$$") or die "$0: poll_mail: open $tmpfile_prefix$$: $!\n" ;
	    print DECFD $msg{body} ;
	    close (DECFD) or die "$0: poll_mail: close $tmpfile_prefix$$: $!\n" ;

	    open (DECFD, "$decoder $decoder_parms $tmpfile_prefix$$ |") or die "$0: poll_mail: open-decoder: $!\n" ;
      	    while (<DECFD>) {
	      dbg("poll_mail: <DECFD> length is", length($_), ".", 8);
	      $origmsg.= $_ ;
	    }
	    
	    close DECFD ;
	    unlink("$tmpfile_prefix$$") ;

	    dbg("poll_mail: post-decode (", time(), ")", 7);
	    $msg{from} = undef ;
	    $msg{body} = undef ;
	    dbg("poll_mail: <packet=[", $origmsg, "]", 10) ;

	    dbg("poll_mail: mode==$mode", 6);


	    if ($mode eq "forward") {
	      dbg("poll_mail: sending", length($origmsg), "bytes of data to SOCKFD", 5);
	      send(SOCKFD, $origmsg, 0) or die "$0: poll_mail:send SOCKFD: $!\n" ;
	      
	     } else {
	       dbg("poll_mail: sending", length($origmsg), "bytes of data to CLIFD", 5);
	       send(CLIFD, $origmsg, 0) or die "$0: poll_mail:send CLIFD: $!\n" ;
	     }
	  }
	  
	}

      }

    }




  $lastline = $origline ;
  }


  dbg("poll_mail end", 4);
  dbg("poll_mail error cleanup: $!", 4);
  return(1);
}




sub start_poll_mail {


  if (!(-e $maildrop)) { 
    dbg("Maildrop ($maildrop) not found (!-e)", 1);
    return(0); 
  }

  if ($clear_maildrop == 1) {
    dbg("start_poll_mail: clearing maildrop", 3) ;
    `/bin/echo \"\" > $maildrop` ;
  }

  dbg("start_poll_mail: attempting to open $maildrop", 3);
  open DROPFD, "<$maildrop" or die "$0: open $maildrop: $!\n"; 



return(1);
}





sub dbg {
  my $dbg_level = pop @_ ;
  my $dbg_msg = "@_" ;

  print STDERR "DEBUG($dbg_level): $dbg_msg\n" if $debuglevel >= $dbg_level ;
  return(1);
}
